import { createOllamaChatStream } from './stream-chat';

const ollamaUrl = 'http://192.168.31.220:11434';

export const createResponse = (response: Response) => {
  const reader = response.body!.getReader();
  const decoder = new TextDecoder('utf-8');
  let done = false;
  let result = '';
  reader.read().then(function processText({ done, value }) {
    if (done) {
      console.log('Stream complete');
      done = true;
      return;
    }
    result += decoder.decode(value, { stream: true });
    return reader.read().then(processText);
  });
  return result;
};
type OllamaResponse = {
  context: number[];
  created_at: string;
  done: boolean;
  done_reason: string;
  eval_count: number;
  eval_duration: number;
  model: string;
  prompt_eval_count: number;
  prompt_eval_duration: number;
  response: string;
  total_duration: number;
};
export const postOllama = async (prompt: string): Promise<OllamaResponse> => {
  const response = await fetch(`${ollamaUrl}/api/generate`, {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
    },
    body: JSON.stringify({
      model: 'qwen2.5:14b',
      prompt,
      stream: false,
    }),
  });
  return await response.json();
};
export const previewResponse = async (response: Response) => {
  const reader = response.body!.getReader();
  const decoder = new TextDecoder('utf-8');
  let done = false;

  while (!done) {
    const { value, done: streamDone } = await reader.read();
    done = streamDone;

    if (value) {
      const chunk = decoder.decode(value, { stream: true });
      console.log(chunk);
      // 在页面实时显示流返回的内容
      document.getElementById('output')!.innerText += chunk;
    }
  }
};
export const postOllamaStrem = async (prompt: string) => {
  const res = await fetch(`${ollamaUrl}/api/generate`, {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
    },
    body: JSON.stringify({
      model: 'qwen2.5:14b',
      prompt: prompt,
      stream: true, // 启用流式返回
    }),
  });

  const readSteam = await createOllamaChatStream(res);
  // previewResponse(readSteam)
  return readSteam;
};
