export const StreamChat = async (response: Response) => {
  // const response = await fetch(request);
  const reader = response?.body!.getReader();
  const decoder = new TextDecoder();
  const encoder = new TextEncoder();
  const readableStream = new ReadableStream({
    async start(controller) {
      function push() {
        reader
          .read()
          .then(({ done, value }) => {
            if (done) {
              try {
                controller.close();
              } catch (e) {
                //
              }
              return;
            }
            const chunk = decoder.decode(value, { stream: true });
            const messageList = chunk.split('\n\n').filter((message) => message);
            messageList.forEach((message) => {
              // const message = chunk.replace('data: ', '');
              message = message.replace('data: ', '');
              console.log(chunk);
              console.log(message);
              if (message === '[DONE]') {
                // controller.close();
                return;
              }
              const parsed = JSON.parse(message);
              controller.enqueue(encoder.encode(parsed.choices[0].delta.content));
            });
            push();
          })
          .catch((err) => {
            console.error('读取流中的数据时发生错误', err);
            controller.error(err);
          });
      }
      push();
    },
  });
  return new Response(readableStream);
};

export const createOllamaChatStream = async (response: Response) => {
  // const response = await fetch(request);
  const reader = response?.body!.getReader();
  const decoder = new TextDecoder();
  const encoder = new TextEncoder();
  const readableStream = new ReadableStream({
    async start(controller) {
      function push() {
        reader
          .read()
          .then(({ done, value }) => {
            if (done) {
              try {
                controller.close();
              } catch (e) {
                //
              }
              return;
            }
            const chunk = decoder.decode(value, { stream: true });
            // try {
            //   const parsed = JSON.parse(chunk)
            //   console.log(parsed)
            //   controller.enqueue(encoder.encode(parsed.response))
            //   push()
            // } catch (e) {
            //   console.error('解析流中的数据时发生错误', e)
            //   console.error('解析的流', chunk)
            //   // controller.error(e)
            // }
            // console.log('parsex chunk', chunk)
            const messageList = chunk.split('\n').filter((message) => message);
            messageList.forEach((message) => {
              // console.log('message', message, '\nchunk:', chunk)
              if (message === '[DONE]') {
                // controller.close();
                return;
              }
              try {
                const parsed = JSON.parse(message);
                controller.enqueue(encoder.encode(parsed.response));
                push();
              } catch (e) {
                console.error('解析流中的数据时发生错误', e);
                console.error('解析的流', message);
                // controller.error(e)
              }
            });
          })
          .catch((err) => {
            console.error('读取流中的数据时发生错误', err);
            controller.error(err);
            push();
          });
      }
      push();
    },
  });
  return new Response(readableStream);
};
